<?PHP
/**
* Copyright 2009-2012 http://nfhelp.ru/
* ==========================================
*   v0.1
*/

$default = array(
'image' => "/miniposter/noavatar.png",	#   ,       
'width' => 100,		#  
'height' => 100,	#  
'crop' => 1,		#   / (1/0)
'quality' => 85,	#  : 1-100
'margin' => '0,0,0,0', #    ,    margin  css.

'width_max' => 1000, #   
'height_max' => 1000, #   
'allow_overlay' => 1, #     

'lifetime' => 86400*7,	#     ,   (86400 = 60*60*24, ).  ,    
'allow_remote_url' => 1, #      
'force_jpg' => 0,	#      jpg ,   . (, png -    2-3     )
);

@error_reporting ( E_ALL ^ E_WARNING ^ E_NOTICE );
@ini_set( 'display_errors', true );
@ini_set( 'html_errors', false );
@ini_set( 'error_reporting', E_ALL ^ E_WARNING ^ E_NOTICE );
@ini_set( 'gd.jpeg_ignore_warning', true );
define( 'ROOT_DIR', substr( dirname(  __FILE__ ), 0, -11 ) );
define( 'CACHE_DIR', dirname(  __FILE__ )."/cache/" );
define( 'MOD_DIR', dirname(  __FILE__ ) );

$doverlay = false;
if($_GET['overlay'] AND $default['allow_overlay']){
	$overlay = preg_replace("#[^a-z0-9]#i","",$_GET['overlay']);
	if(file_exists(MOD_DIR."/overlay/{$overlay}.png")){
		$info = getimagesize(MOD_DIR."/overlay/{$overlay}.png");
		if($info[0]>0 AND $info[1]>0){
			if(!$_GET['margin']) $margin = $default['margin'];
			else $margin = $_GET['margin'];
			$margin = explode(",",$margin);
			$m = array();
			for($i=0;$i<4;$i++){
				if(intval($margin[$i])>0) $m[$i] = intval($margin[$i]);
				elseif($i==1) $m[$i] = $m[0];
				elseif($i==2) $m[$i] = $m[0];
				elseif($i==3) $m[$i] = $m[1];
				else $m[$i] = 0;
			}
			$w = $info[0]-$m[1]-$m[3];
			$h = $info[1]-$m[0]-$m[2];
			$crop = 1;
			$doverlay = true;
		}else $_GET['src'] = '';
	}else $_GET['src'] = '';
}else{
	$w = intval($_GET['w']);
	if($w<1) $w = $default['width'];
	elseif($w>$default['width_max']) $w = $default['width_max'];
	$h = intval($_GET['h']);
	if($h<1) $h = $default['height'];
	elseif($h>$default['height_max']) $h = $default['height_max'];
	if(!isset($_GET['zc'])) $crop = 1;
	else $crop = intval($_GET['zc']);
}
$q = intval($_GET['q']);
if($q<1 OR $q>100) $q = $default['quality'];
if(!isset($_GET["src"]) OR $_GET["src"]=='') $_GET["src"] = $default['image'];
$src = clean_source( $_GET["src"] );
$file = pathinfo($src);
$file['extension'] = strtolower($file['extension']);
$types = array(
	'jpg'  => 'image/jpeg',
	'jpeg' => 'image/jpeg',
	'png'  => 'image/png',
	'gif'  => 'image/gif'
);
$mime_type = $types[$file['extension']];
if(!$mime_type){
	$src = ROOT_DIR.$default['image'];
	$mime_type = 'image/png';
}
if($default['force_jpg']) $savetype = "jpg";
else $savetype = $file['extension'];
if($doverlay){
	if(!is_dir(CACHE_DIR."{$overlay}/")){
		@mkdir(CACHE_DIR."{$overlay}/",0777);
		@chmod(CACHE_DIR."{$overlay}/",0777);
	}
	$cache_file = CACHE_DIR."{$overlay}/".md5($file['filename'].$q.implode(",",$m)).".".$savetype;
}else{
	if(!is_dir(CACHE_DIR."{$w}/")){
		@mkdir(CACHE_DIR."{$w}/",0777);
		@chmod(CACHE_DIR."{$w}/",0777);
	}
	if(!is_dir(CACHE_DIR."{$w}/{$h}/")){
		@mkdir(CACHE_DIR."{$w}/{$h}/",0777);
		@chmod(CACHE_DIR."{$w}/{$h}/",0777);
	}
	$cache_file = CACHE_DIR."{$w}/{$h}/".md5($file['filename'].$crop.$q).".".$savetype;
}
if(file_exists($cache_file)) get_from_cache();
$image = imagecreatefromstring(@file_get_contents($src));
$iw = @imagesx( $image );
$ih = @imagesy( $image );
if($iw<$w) $w = $iw;
if($ih<$h) $h = $ih;
$poster = imagecreatetruecolor($w,$h);
$fill = imagecolorallocate($poster,255,255,255);
imagefill($poster,0,0,$fill);
if($crop){
	$size_ratio = max($w/$iw,$h/$ih);
	$nw = $iw * $size_ratio;
	$nh = $ih * $size_ratio;
	$sx = -floor(($nw-$w)/2);
	$sy = -floor(($nh-$h)/2);
}else{
	$nw = $w;
	$nh = $h;
	$sx = $sy = 0;
}
imagealphablending($poster,false);
imagesavealpha($poster,true);
imagecopyresampled($poster,$image,$sx,$sy,0,0,$nw,$nh,$iw,$ih);
if($doverlay){
	$bg = imagecreatetruecolor($info[0],$info[1]);
	#imagealphablending($bg,false);
	#imagesavealpha($bg,true);
	imagecopy($bg,$poster,$m[3],$m[0],0,0,$w,$h);
	$cover = imagecreatefrompng(MOD_DIR."/overlay/{$overlay}.png");
	imagecopy($bg,$cover,0,0,0,0,$info[0],$info[1]);
	$poster = $bg;
}
if($default['force_jpg']) imagejpeg($poster, $cache_file, $q);
else{
	if($file['extension'] == 'gif') imagegif($poster, $cache_file);
	elseif($file['extension'] == 'jpeg' OR $file['extension'] == 'jpg') imagejpeg($poster, $cache_file, $q);
	elseif($file['extension'] == 'png'){
		$quality = floor($q * 0.09);		
		imagepng($poster, $cache_file, $quality);
	}
}
get_from_cache();
function get_from_cache(){
	global $cache_file,$mime_type,$default;
	$date = filemtime($cache_file);
	$lifetime = time() - $date;
	if($default['lifetime'] AND $lifetime > $default['lifetime']){
		unlink($cache_file);
		return false;
	}else{
		$fileSize = filesize($cache_file);
		header("Content-Type: " . $mime_type);
		header("Content-Length: " . $fileSize);
		header("Last-Modified: " . gmdate('D, d M Y H:i:s', filemtime($cache_file)) . " GMT");
		header("Cache-Control: max-age={$default['lifetime']}, must-revalidate");
		header("Expires: " . gmdate("D, d M Y H:i:s", time() + $default['lifetime']) . "GMT");
		echo file_get_contents($cache_file);
		die();
	}
}
function clean_source($src){
	global $default;
	if(stripos($src,"://".$_SERVER['HTTP_HOST'])!==false OR stripos($src,"://")==false){
		if(stripos($src,"://")!==false){
			preg_match("#://[^/]+/(.*)#i",$src,$file);
			$src = $file[1];
		}
		$src = ROOT_DIR.str_replace("//","/",str_replace("../","","/".$src));
		if(file_exists($src)) return $src;
		return ROOT_DIR.$default['image'];
	}elseif($default['allow_remote_url']){
		return $src;
	}
}
?>